# IExNativeFileFormat Struct Reference
[External Interfaces]

Inheritance diagram for IExNativeFileFormat:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | ReadComponent (IShTokenStream *stream, IShParameterComponent **component)=0
virtual MCCOMErr MCCOMAPI | ReadComponent (IShTokenStream *stream, IShParameterComponent **component, IDType familyID)=0
virtual MCCOMErr MCCOMAPI | WriteComponent (IShTokenStream *stream, IShParameterComponent *component)=0
virtual MCCOMErr MCCOMAPI | ReadComponentData (IShTokenStream *stream, IShParameterComponent *component)=0
virtual MCCOMErr MCCOMAPI | WriteComponentData (IShTokenStream *stream, IShParameterComponent *component)=0
virtual MCCOMErr MCCOMAPI | ReadTimeBased (IShTokenStream *stream, ITimeBased *timeBased)=0
virtual MCCOMErr MCCOMAPI | WriteTimeBased (IShTokenStream *stream, IDType keyword, ITimeBased *timeBased)=0
virtual MCCOMErr MCCOMAPI | ReadTextureMap (IShTokenStream *stream, IShTextureMap **texture)=0
virtual MCCOMErr MCCOMAPI | WriteTextureMap (IShTokenStream *stream, IDType keyword, IShTextureMap *texture)=0
virtual MCCOMErr MCCOMAPI | ReadHeader (IShTokenStream *stream, TMCCountedPtrArray< I3DShModule > &modules, TMCPtrArray< TMCString > &cameraNames)=0
virtual MCCOMErr MCCOMAPI | ReadSceneFromStream (I3DShScene *scene, TMCiostream *stream, I3DShTreeElement *fatherTree, const TMCString &fatherTreeName, TImportInfo *ioImportInfo=NULL)=0
virtual MCCOMErr MCCOMAPI | StartReadingFile ()=0
virtual MCCOMErr MCCOMAPI | EndReadingFile ()=0
virtual MCCOMErr MCCOMAPI | StartWritingFile ()=0
virtual MCCOMErr MCCOMAPI | EndWritingFile ()=0

## Detailed Description

The interface of the Native (Carrara file format) import/export.

## Member Function Documentation

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::EndReadingFile | ( |  | ) | `[pure virtual]`

Should be called at the end of reading a file Note: use CWhileReadingNativeFF instead

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::EndWritingFile | ( |  | ) | `[pure virtual]`

Should be called at the end of writing a file Note: use CWhileWritingNativeFF instead

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadComponent | ( | IShTokenStream * | stream,
|  | IShParameterComponent ** | component,
|  | IDType | familyID |
| ) |  |  | `[pure virtual]`

Reads a component from a token stream. The family ID was already read (not the begin token).

Parameters:

  | stream | The token stream.
  | component | The component that is created.
  | familyID | The family ID.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadComponent | ( | IShTokenStream * | stream,
|  | IShParameterComponent ** | component |
| ) |  |  | `[pure virtual]`

Reads a component from a token stream.

Parameters:

  | stream | The token stream.
  | component | The component that is created.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadComponentData | ( | IShTokenStream * | stream,
|  | IShParameterComponent * | component |
| ) |  |  | `[pure virtual]`

Reads a component from a token stream. The family ID and class ID have already been read.

Parameters:

  | stream | The token stream.
  | component | The component that is created.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadHeader | ( | IShTokenStream * | stream,
|  | TMCCountedPtrArray< I3DShModule > & | modules,
|  | TMCPtrArray< TMCString > & | cameraNames |
| ) |  |  | `[pure virtual]`

Reads the header of a file.

Parameters:

  | stream | The token stream.
  | modules | The list of modules
  | cameraNames | The list of camera names.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadSceneFromStream | ( | I3DShScene * | scene,
|  | TMCiostream * | stream,
|  | I3DShTreeElement * | fatherTree,
|  | const TMCString & | fatherTreeName,
|  | TImportInfo * | ioImportInfo = `NULL` |
| ) |  |  | `[pure virtual]`

Reads a scene from a token stream.

Parameters:

  | scene | The scene that is read.
  | stream | The token stream.
  | fatherTree | A pointer the parent tree under which the scene should be imported..
  | fatherTreeName | The name of the father tree.
  | inAutoPlaceInfo | Optional data to position the imported data

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadTextureMap | ( | IShTokenStream * | stream,
|  | IShTextureMap ** | texture |
| ) |  |  | `[pure virtual]`

Reads a texture map from a token stream.

Parameters:

  | stream | The token stream.
  | texture | The texture that is created.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::ReadTimeBased | ( | IShTokenStream * | stream,
|  | ITimeBased * | timeBased |
| ) |  |  | `[pure virtual]`

Read a time based from a token stream.

Parameters:

  | stream | The token stream.
  | timeBased | The timebased.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::StartReadingFile | ( |  | ) | `[pure virtual]`

Should be called when starting to read a file Note: use CWhileReadingNativeFF instead

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::StartWritingFile | ( |  | ) | `[pure virtual]`

Should be called when starting to write a file Note: use CWhileWritingNativeFF instead

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::WriteComponent | ( | IShTokenStream * | stream,
|  | IShParameterComponent * | component |
| ) |  |  | `[pure virtual]`

Writes a component to a token stream (file).

Parameters:

  | stream | The token stream.
  | component | The component that is created.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::WriteComponentData | ( | IShTokenStream * | stream,
|  | IShParameterComponent * | component |
| ) |  |  | `[pure virtual]`

Write the component data.

Parameters:

  | stream | The token stream.
  | component | The component.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::WriteTextureMap | ( | IShTokenStream * | stream,
|  | IDType | keyword,
|  | IShTextureMap * | texture |
| ) |  |  | `[pure virtual]`

Writes a texture map to a token stream (file).

Parameters:

  | stream | The token stream.
  | keyword | The keyword that identify the texture map.
  | texture | The texture that is created.

virtual MCCOMErr MCCOMAPI IExNativeFileFormat::WriteTimeBased | ( | IShTokenStream * | stream,
|  | IDType | keyword,
|  | ITimeBased * | timeBased |
| ) |  |  | `[pure virtual]`

Writes a time based to a token stream.

Parameters:

  | stream | The token stream.
  | keyword | The keyword that identify the timebased.
  | timeBased | The timebased.

The documentation for this struct was generated from the following file:

- IExNativeFileFormat.h